﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.display.CapsStyle;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.events.MouseEvent;
	import flash.net.FileReference;
	import flash.utils.ByteArray;
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	import org.alivepdf.annotations.TextAnnotation;
	import org.alivepdf.annotations.AnnotationType;
	import org.alivepdf.annotations.Annotation;
	import org.alivepdf.colors.RGBColor;
	import org.alivepdf.saving.Method;

	import org.alivepdf.links.HTTPLink;
	import org.alivepdf.colors.CMYKColor;
	
	import org.alivepdf.colors.SpotColor;

	import org.alivepdf.drawing.Blend;
	import org.alivepdf.events.ProcessingEvent;
	import org.alivepdf.layout.Position;
	import org.alivepdf.layout.Mode;
	import org.alivepdf.layout.Resize;

	
	import org.alivepdf.fonts.IFont;
	import org.alivepdf.fonts.FontFamily;
	import org.alivepdf.fonts.CoreFont;
	import org.alivepdf.pages.Page;
	import org.alivepdf.display.Display;
	import org.alivepdf.layout.Layout;
	import org.alivepdf.layout.Size;
	import org.alivepdf.layout.Unit;
	import org.alivepdf.layout.Orientation;
	import org.alivepdf.pdf.PDF;

	

	import com.demonsters.debugger.MonsterDebugger;

	/**
	 * La classe Main qui étend Sprite.
	 * 
	 * définit le nombre d'images par secondes dans les paramètres de compilation
	 * -default-frame-rate 10
	 * 
	 * source : http://alivepdf.bytearray.org/
	 * 
	 */
	public class Main extends Sprite
	{
		private var oFile : FileReference;
		private var oPDF : PDF;
		private var oImage : Loader;


		/**
		 * Constructeur.
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 10
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			initPDF();
			buildUI();
		}
		
		
		/**
		 * Préparation du document pdf.
		 * 
		 */
		private function initPDF() : void
		{
			// création d'un pdf, avec orientation portrait, unités millimètres, format A4
			oPDF = new PDF(Orientation.PORTRAIT, Unit.MM, Size.A4);

			// les différents évènements diffusés par l'objet PDF
			oPDF.addEventListener(ProcessingEvent.STARTED, generationStarted);
			oPDF.addEventListener(ProcessingEvent.PAGE_TREE, pageTreeGeneration);
			oPDF.addEventListener(ProcessingEvent.RESOURCES, resourcesEmbedding);
			oPDF.addEventListener(ProcessingEvent.COMPLETE, generationComplete);

			oPDF.setDisplayMode(Display.FULL_PAGE, Layout.SINGLE_PAGE);
			
			// configuration des propriétés du document pdf
			oPDF.setTitle("Cours AS3 Facile");
			oPDF.setSubject("Utiliser AlivePDF avec ActionScript 3");
			oPDF.setCreator("Matthieu pour ActionScript-Facile.com");
			
			var newPage : Page = new Page(Orientation.PORTRAIT, Unit.MM, Size.A4);
			oPDF.addPage(newPage); // création d'une page
			oPDF.textStyle(new RGBColor( Math.random() * 0X00FFFFFF ), 1); // couleur du texte du pdf
			
			// la police par défaut du document pdf
			var oCoreFont : IFont = new CoreFont(FontFamily.ARIAL);
			oPDF.setFont(oCoreFont, 20);// la taille de la police
		}

		private function buildUI() : void
		{
			oFile = new FileReference();

			// chargement des éléments
			// création du conteneur de l'image
			oImage = new Loader();
			oImage.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);
			oImage.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onError);
			var image : URLRequest = new URLRequest("nature.jpg");
			oImage.load(image);
			addChild(oImage);
			
			// le bouton de génération du pdf
			var oBtnDonwloadPdf : DefaultButton = new DefaultButton();
			oBtnDonwloadPdf.getObject().label = "Créer le pdf";
			oBtnDonwloadPdf.getObject().x = 430;
			oBtnDonwloadPdf.getObject().y = 360;
			oBtnDonwloadPdf.getObject().addEventListener(MouseEvent.CLICK, onPdfDownload);
			addChild(oBtnDonwloadPdf);
		}




		private function onError(event : IOErrorEvent) : void
		{
			MonsterDebugger.trace(this, onError);
			MonsterDebugger.trace(this, event);
		}

		private function onComplete(event : Event) : void
		{
			MonsterDebugger.trace(this, "onComplete");
			createPDF();
		}
		
		
		/**
		 * Création du document pdf directement avec ActionScript 3.
		 * 
		 */
		private function createPDF() : void
		{
			MonsterDebugger.trace(this, "Création du fichier pdf");

			oPDF.addText("Un exemple de texte à côté du cercle dessiné par AlivePDF", 5, 15);// ajout de texte
			oPDF.drawCircle(25, 35, 15);// dessine un cercle
			oPDF.drawEllipse(50, 35, 15, 13);// dessine une ellipse
			
			oPDF.setAlpha( .5, Blend.COLOR );// création d'un effet sur l'image
			oPDF.setXY(90, 100);
			oPDF.addImage(oImage, new Resize(Mode.FIT_TO_PAGE, Position.CENTERED), 28, 15, 0, 0, 30, 0.8);// ajout d'une image
			
			oPDF.addPage();// création d'une page
			// écriture d'un bloc de texte - espace entre les lignes
			oPDF.writeText(10, "Lorem ipsum dolor sit amet, consectetur adipiscing elit.\n\nPraesent vel lectus lorem. Phasellus convallis, tortor a venenatis mattis, erat mi euismod tellus, in fermentum sapien nibh sit amet urna. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent tellus libero, lacinia ac egestas eget, interdum quis purus. Donec ut nisl metus, sit amet viverra turpis. Mauris ultrices dapibus lacus non ultrices. Cras elementum luctus mauris, vitae eleifend diam accumsan ut. Aliquam erat volutpat. Suspendisse placerat nibh in libero tincidunt a elementum mi vehicula. Donec lobortis magna vel nibh mollis tempor. Maecenas et elit nunc. Nam non auctor orci. Aliquam vel velit vel mi adipiscing semper in ac orci. Vestibulum commodo sem eget tortor lobortis semper. Ut sit amet sapien non velit rutrum egestas sollicitudin in elit.\n\nFusce laoreet leo a sem mattis iaculis");

			oPDF.addPage();
			oPDF.setAlpha( .2, Blend.SATURATION );// création d'un effet sur l'image
			oPDF.addImage(oImage, new Resize(Mode.FIT_TO_PAGE, Position.CENTERED));// ajout d'une image
			
			oPDF.newLine(330);
			
			var oCoreFont : IFont = new CoreFont(FontFamily.HELVETICA_OBLIQUE);
			oPDF.setFont(oCoreFont, 22);// mise à jour de police de caractères utilisée
			
			oPDF.textStyle ( new RGBColor( Math.random() * 0X00FFFFFF ), 1 );// transparence sur le texte
			// ajout de texte aux coordonnées 33, 130 - taille 22 pixels
			oPDF.addText("Bienvenue sur les Cours ActionScript Facile !!!", 33, 110);
			
			oPDF.textStyle ( new RGBColor( Math.random() * 0X00FFFFFF ), .8 );// transparence sur le texte
			// ajout de texte aux coordonnées 33, 130 - taille 22 pixels
			oPDF.addText("Bienvenue sur les Cours ActionScript Facile !!!", 33, 120);
			
			oPDF.newLine(63);
			
			oPDF.textStyle ( new RGBColor( Math.random() * 0X00FFFFFF ), .5 );// transparence sur le texte
			// ajout de texte aux coordonnées 33, 130 - taille 22 pixels
			oPDF.addText("Bienvenue sur les Cours ActionScript Facile !!!", 33, 136);
			
			oPDF.textStyle ( new RGBColor( Math.random() * 0X00FFFFFF ), .2 );// transparence sur le texte
			// ajout de texte aux coordonnées 33, 130 - taille 22 pixels
			oPDF.addText("Bienvenue sur les Cours ActionScript Facile !!!", 33, 150);
			
			
			oPDF.addPage();
			oPDF.textStyle ( new RGBColor( Math.random() * 0X00FFFFFF ), 1 );// transparence sur le texte
			oPDF.writeFlashHtmlText(13, "<b>Texte en Gras</b>, <br/> saut de ligne <br/>" +
			"<i>Texte en italique</i>,<br/>et pour finir du <u>texte souligné</u>");
			
			// création d'une annotation
			var annotationVideo:Annotation = new TextAnnotation ( AnnotationType.TEXT, 
			"Voici une annotation Vidéo sur le document pdf!", 80, 80, 200, 200 );
			oPDF.addAnnotation( annotationVideo );// ajotu sur la page courante
			
			oPDF.setFont(oCoreFont, 18);// mise à jour de police de caractères utilisée
			
			// ajotu d'un texte sur pluieurs ligne - choix de la hauteur et espace entre les lignes
			oPDF.addMultiCell(200, 10, 
			"C'est un texte très long sur plusieurs lignes. Il est possible de" +
			"choisir sa hauteur ainsi que l'espace entre les lignes automatiquement." +
			"Merci de suivre ce tutoriel sur AlivePDF avec ActionScript 3.");

			
			var sc:SpotColor = new SpotColor ("Rectangle", new CMYKColor ( 90, 22, 33, 30 ) );
			oPDF.lineStyle( sc );
			oPDF.drawRect( new Rectangle ( 100, 50, 63, 63 ) );
			
			oPDF.addText("Cliquez sur le lien Web", 33, 85);// ajout de texte
			var hyperlink:HTTPLink = new HTTPLink("http://www.actionscript-facile.com");
			oPDF.addLink( 30 , 80, 66, 8, hyperlink );
			
			// création d'une annotation
			var annotationText:Annotation = new TextAnnotation ( AnnotationType.TEXT, 
			"Ceci est une annotation sur le document pdf!", 30, 130, 200, 200 );
			oPDF.addAnnotation( annotationText );// ajotu sur la page courante
			
			oPDF.addPage();
			oPDF.setFont(oCoreFont, 16);// mise à jour de police de caractères utilisée
			oPDF.lineStyle ( new RGBColor ( Math.random() * 0x0033ff ), 1, 0.5, 1, CapsStyle.SQUARE);
			oPDF.drawRect ( new Rectangle ( 20, 20, 168, 205 ) );
			oPDF.setXY(33, 30);
			oPDF.writeText(15, "Et voici du texte encadré dans un rectangle de couleur !!!\n\n" +
			"                      Il est possible d'écriture une longue page de prose...\n\n" +
			"                      Et également de combiner plusieurs texte encadré,\n\n" +
			"                                               c'est good AlivePDF ;)");
			
			oPDF.addPage();
			// ajout d'une image bitmap
			var surface:BitmapData = new Logo ();// création du bitmap
			oPDF.beginBitmapFill( surface );// init avec l'image bitmap
			oPDF.drawRoundRectComplex( new Rectangle ( 0, 0, 545, 770 ), 16, 16, 16, 16 );
			oPDF.endFill();// dessin terminé
		}
		
		
		/**
		 * Création du fichier pdf.
		 * Avec Flash directement pour la version 10 du player.
		 * Avec php pour la version 9 du player.
		 * 
		 */
		private function onPdfDownload(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "onPdfDownload");

			// création du pdf côté client (par le player flash version 10)
			var bytes : ByteArray = oPDF.save(Method.LOCAL);
			oFile.save(bytes, "actionscript-facile.pdf");

			// ancienne méthode en appelant un script php (côté serveur) par le player version 9
			/*oPDF.save(Method.REMOTE, 
			"http://www.actionscript-facile.com/ressources/php/create-pdf.php", 
			Download.ATTACHMENT, "actionscript-facile.pdf");*/
		}
		
		private function generationStarted(pEvt : ProcessingEvent) : void
		{
			MonsterDebugger.trace(this,"pdf generation initiated : " + pEvt.duration / 1000 + " secondes");
		}

		private function pageTreeGeneration(pEvt : ProcessingEvent) : void
		{
			MonsterDebugger.trace(this,"page tree generated in : " + pEvt.duration / 1000 + " secondes");
		}

		private function resourcesEmbedding(pEvt : ProcessingEvent) : void
		{
			MonsterDebugger.trace(this,"resources embedded : " + pEvt.duration / 1000 + " secondes");
		}

		private function generationComplete(pEvt : ProcessingEvent) : void
		{
			MonsterDebugger.trace(this,"pdf generated in : " + pEvt.duration / 1000 + " secondes");
		}
	}
}
